/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { __extends } from "tslib";
import { EventProxy } from "./EventProxy";
import { Point_$type, runOn, markType, PointUtil, String_$type, Delegate_$type } from "./type";
import { Rect } from "./Rect";
import { MouseEventArgs } from "./MouseEventArgs";
import { Dictionary$2 } from "./Dictionary$2";
import { List$1 } from "./List$1";
/**
 * @hidden
 */
var BaseDOMEventProxy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(BaseDOMEventProxy, _super);
    function BaseDOMEventProxy() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.b3 = null;
        _this.bu = false;
        _this.bw = false;
        _this.b2 = null;
        _this.bn = false;
        _this.b0 = 0;
        _this.b1 = 0;
        _this.by = 0;
        _this.bz = 0;
        _this.b4 = 0;
        _this.c2 = null;
        _this.c1 = null;
        _this.bm = false;
        _this.b5 = -1;
        _this.br = false;
        _this.bo = false;
        _this.bl = false;
        return _this;
    }
    BaseDOMEventProxy.prototype.d = function () {
        var a = new DOMEventProxy(this.b3, this.b2, this.bw);
        a.ab = this.ab;
        a.ao = this.ao;
        return a;
    };
    Object.defineProperty(BaseDOMEventProxy, "bx", {
        get: function () {
            return (BaseDOMEventProxy.bs || BaseDOMEventProxy.bt);
        },
        enumerable: false,
        configurable: true
    });
    BaseDOMEventProxy.prototype.bj = function (a) {
        return DOMEventProxy.c3(a);
    };
    BaseDOMEventProxy.prototype.bq = function (e_) {
        var pointerEvent_ = e_.originalEvent;
        var a = false;
        if (BaseDOMEventProxy.bt) {
            a = (pointerEvent_.pointerType == 'touch');
        }
        else {
            a = (pointerEvent_.pointerType == pointerEvent_.MSPOINTER_TYPE_TOUCH);
        }
        return a;
    };
    BaseDOMEventProxy.prototype.ct = function (a) {
        if (!this.ae) {
            if (this.bp(a)) {
                if (this.aq == null || this.aq(a)) {
                    a.preventDefault();
                }
            }
        }
    };
    BaseDOMEventProxy.prototype.bp = function (e_) {
        return (e_.originalEvent.cancelable || e_.originalEvent.cancelable == undefined);
    };
    BaseDOMEventProxy.prototype.cp = function () {
        var source_ = this.b3.getNativeElement();
        BaseDOMEventProxy.cs(source_);
    };
    BaseDOMEventProxy.cs = function (source_) {
        if (BaseDOMEventProxy.bt) {
            source_.style.touchAction = 'none';
        }
        else {
            source_.style.msTouchAction = 'none';
        }
        source_.style.msUserSelect = 'none';
        source_.style.webkitTouchCallout = 'none';
        source_.style.webkitUserSelect = 'none';
        source_.style.khtmlUserSelect = 'none';
        source_.style.mozUserSelect = 'none';
        source_.style.userSelect = 'none';
    };
    BaseDOMEventProxy.cm = function (source_) {
        if (BaseDOMEventProxy.bt) {
            source_.style.touchAction = 'auto';
        }
        else {
            source_.style.msTouchAction = 'auto';
        }
        source_.style.msUserSelect = 'auto';
        source_.style.webkitTouchCallout = 'none';
        source_.style.webkitUserSelect = 'auto';
        source_.style.khtmlUserSelect = 'auto';
        source_.style.mozUserSelect = 'auto';
        source_.style.userSelect = 'auto';
    };
    BaseDOMEventProxy.prototype.cn = function () {
        var source_ = this.b3.getNativeElement();
        BaseDOMEventProxy.cm(source_);
    };
    BaseDOMEventProxy.prototype.av = function () {
        _super.prototype.av.call(this);
        if (!this.ae) {
            this.cp();
        }
        else {
            this.cn();
        }
    };
    BaseDOMEventProxy.prototype.ca = function () {
        var ver_ = -1;
        var matchIE_ = /Trident\/([\d.]+)/;
        if ((matchIE_.exec(navigator.userAgent) != null)) {
            ver_ = (parseFloat(RegExp.$1));
        }
        return ver_;
    };
    BaseDOMEventProxy.prototype.b9 = function () {
        var ver_ = -1;
        var matchIE_ = /Edge\/([\d.]+)/;
        if ((matchIE_.exec(navigator.userAgent) != null)) {
            ver_ = (parseFloat(RegExp.$1));
        }
        return ver_;
    };
    BaseDOMEventProxy.cr = function (e_) {
        var a = BaseDOMEventProxy.cb >= 6;
        var oe_ = e_.originalEvent;
        if ((((typeof e_.pageX == 'undefined')) || a) && oe_.clientX != null) {
            var od_ = void 0;
            if ((e_.target !== undefined)) {
                od_ = e_.target.ownerDocument;
            }
            else {
                od_ = e_.originalEvent.target.ownerDocument;
            }
            var ed_ = od_ ? od_ : document;
            var doc_ = ed_.documentElement;
            var body_ = ed_.body;
            var clientX_ = oe_.clientX;
            var clientY_ = oe_.clientY;
            var scrollLeft_ = doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0;
            var scrollTop_ = doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0;
            var clientLeft_ = doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0;
            var clientTop_ = doc_ && doc_.clientTop || body_ && body_.clientTop || 0;
            e_.pageX = clientX_ + (scrollLeft_ - clientLeft_);
            e_.pageY = clientY_ + (scrollTop_ - clientTop_);
        }
        if ((!e_.pageX)) {
            e_.pageX = e_.originalEvent.pageX;
        }
        if ((!e_.pageY)) {
            e_.pageY = e_.originalEvent.pageY;
        }
        if (((typeof e_.button == 'undefined')) && ((typeof oe_.button != 'undefined'))) {
            e_.button = oe_.button;
        }
    };
    BaseDOMEventProxy.c3 = function (a) {
        var b = BaseDOMEventProxy.cb >= 6;
        var source_ = a.getNativeElement();
        var d_ = source_.ownerDocument;
        var doc_ = d_ ? d_.documentElement : null;
        var z_ = doc_ ? doc_.msContentZoomFactor : null;
        var body_ = doc_.body;
        if ((z_ && z_ > 1) || b) {
            var rect_ = source_.getBoundingClientRect();
            var x_ = (rect_.left);
            var y_ = (rect_.top);
            var scrollLeft_ = (doc_ && doc_.scrollLeft || body_ && body_.scrollLeft || 0);
            var scrollTop_ = (doc_ && doc_.scrollTop || body_ && body_.scrollTop || 0);
            var clientLeft_ = (doc_ && doc_.clientLeft || body_ && body_.clientLeft || 0);
            var clientTop_ = (doc_ && doc_.clientTop || body_ && body_.clientTop || 0);
            var c = x_ + scrollLeft_ - clientLeft_;
            var d = y_ + scrollTop_ - clientTop_;
            return new Rect(0, c, d, 0, 0);
        }
        else {
            var e = a.getOffset();
            return new Rect(0, e.left, e.top, 0, 0);
        }
    };
    Object.defineProperty(BaseDOMEventProxy.prototype, "b7", {
        get: function () {
            return this.b4;
        },
        set: function (a) {
            this.b4 = a;
        },
        enumerable: false,
        configurable: true
    });
    BaseDOMEventProxy.prototype.cw = function (a) {
        this.ar = a;
        BaseDOMEventProxy.cr(a);
        var b = BaseDOMEventProxy.c3(this.b3);
        var c = 0;
        var d = 0;
        if (Rect.l_op_Inequality(this.bk, null)) {
            c = this.bk.left;
            d = this.bk.top;
        }
        this.b0 = a.pageX - b.left;
        this.b1 = a.pageY - b.top;
        this.by = this.b0 - c;
        this.bz = this.b1 - d;
        this.c2 = { $type: Point_$type, x: this.b0, y: this.b1 };
        this.c1 = { $type: Point_$type, x: this.by, y: this.bz };
    };
    BaseDOMEventProxy.prototype.cx = function (e_) {
        this.ar = e_;
        BaseDOMEventProxy.cr(e_);
        if (BaseDOMEventProxy.bx) {
            var a = e_.pageX;
            var b = e_.pageY;
            var c = BaseDOMEventProxy.c3(this.b3);
            this.b0 = a - c.left;
            this.b1 = b - c.top;
        }
        else {
            this.b4 = 0;
            if (!e_.originalEvent.targetTouches || e_.originalEvent.targetTouches.length < 1) {
                return;
            }
            ;
            this.b4 = (e_.originalEvent.targetTouches.length);
            var d = (e_.originalEvent.targetTouches[0].pageX);
            var e = (e_.originalEvent.targetTouches[0].pageY);
            var f = BaseDOMEventProxy.c3(this.b3);
            this.b0 = d - f.left;
            this.b1 = e - f.top;
        }
        var g = 0;
        var h = 0;
        if (Rect.l_op_Inequality(this.bk, null)) {
            g = this.bk.left;
            h = this.bk.top;
        }
        this.by = this.b0 - g;
        this.bz = this.b1 - h;
        this.c2 = { $type: Point_$type, x: this.b0, y: this.b1 };
        this.c1 = { $type: Point_$type, x: this.by, y: this.bz };
    };
    BaseDOMEventProxy.prototype.cl = function (e_) {
        this.cv(e_);
        if (this.ad(this.c2, false, true)) {
            var deltaY_ = 0;
            var ev_ = e_;
            deltaY_ = (ev_.originalEvent ? ev_.originalEvent.deltaY : ev_.deltaY);
            var deltaX_ = 0;
            deltaX_ = (ev_.originalEvent ? ev_.originalEvent.deltaX : ev_.deltaX);
            var a = (ev_.originalEvent ? (ev_.originalEvent.deltaMode == 1) : (ev_.deltaMode == 1));
            if (a) {
                deltaY_ = deltaY_ * 40;
                deltaX_ = deltaX_ * 40;
            }
            var b = this.ai(this.c1, deltaY_);
            var c = this.aj(this.c1, deltaX_);
            if (b || c) {
                this.ct(e_);
            }
        }
    };
    BaseDOMEventProxy.prototype.cj = function (e_) {
        this.cv(e_);
        this.cw(e_);
        if (this.ad(this.c2, false, true)) {
            var ev_ = e_;
            var delta_ = 0;
            if (ev_.wheelDelta) {
                delta_ = ev_.wheelDelta / 120;
            }
            ;
            if (ev_.originalEvent && ev_.originalEvent.wheelDelta) {
                delta_ = ev_.originalEvent.wheelDelta / 120;
            }
            ;
            if (ev_.detail) {
                delta_ = -ev_.detail / 3;
            }
            ;
            if (ev_.originalEvent && ev_.originalEvent.detail) {
                delta_ = -ev_.originalEvent.detail / 3;
            }
            ;
            delta_ = delta_ / 10;
            var a = this.ai(this.c1, delta_);
            if (a) {
                this.ct(e_);
            }
        }
    };
    BaseDOMEventProxy.prototype.cq = function () {
        if (this.bm) {
            if (this.b5 == -1) {
                this.b5 = this.b2.setTimeout(runOn(this, this.co), 500);
            }
            else {
                window.clearTimeout(this.b5);
                this.b5 = -1;
                this.b5 = this.b2.setTimeout(runOn(this, this.co), 500);
            }
        }
    };
    BaseDOMEventProxy.prototype.cc = function () {
        this.bm = true;
        if (this.b5 != -1) {
            window.clearTimeout(this.b5);
            this.b5 = -1;
        }
    };
    BaseDOMEventProxy.prototype.co = function () {
        this.bm = false;
    };
    Object.defineProperty(BaseDOMEventProxy.prototype, "bv", {
        get: function () {
            return this.bo;
        },
        set: function (a) {
            this.bo = a;
        },
        enumerable: false,
        configurable: true
    });
    BaseDOMEventProxy.prototype.ch = function (a) {
        if (this.bo || this.bm) {
            return;
        }
        this.cw(a);
        if (this.br) {
            this.br = false;
            this.a8(this.c1);
        }
    };
    BaseDOMEventProxy.prototype.ci = function (a) {
        if (this.bo || this.bm) {
            return;
        }
        this.cw(a);
        this.cv(a);
        var b = new MouseEventArgs();
        b.position = this.c2;
        if (this.ad(this.c2, false, false)) {
            if (!this.br) {
                this.br = true;
                this.a7(this.c2);
            }
            this.a9(this.c2, true, false);
            this.ax(this.c1, false);
        }
        else if (this.br) {
            this.ch(a);
        }
    };
    BaseDOMEventProxy.prototype.cu = function (a) {
        this.b3.focus(this.bu);
    };
    BaseDOMEventProxy.prototype.cg = function (a) {
        if (this.bo || this.bm) {
            return;
        }
        this.cu(a);
        this.cw(a);
        this.cv(a);
        if (this.ad(this.c2, false, false)) {
            this.bl = true;
            this.a6(this.c2);
            this.ay(this.c1, false);
            this.ct(a);
        }
    };
    BaseDOMEventProxy.prototype.cy = function (a) {
        if (this.bo || this.bm) {
            return;
        }
        if (this.bl) {
            this.ck(a);
        }
    };
    BaseDOMEventProxy.prototype.ck = function (a) {
        if (this.bo || this.bm) {
            return;
        }
        this.cv(a);
        if (PointUtil.equals(this.c2, null) || PointUtil.equals(this.c1, null)) {
            this.cw(a);
        }
        var b = this.ad(this.c2, false, false) || this.bl || this.br;
        this.bl = false;
        this.ba(this.c2);
        this.aw(this.c1, false, false);
        if (b) {
            this.ct(a);
        }
    };
    BaseDOMEventProxy.prototype.cd = function (a) {
        this.ce(a, true);
    };
    BaseDOMEventProxy.prototype.cf = function (a) {
        this.ce(a, false);
    };
    BaseDOMEventProxy.prototype.c0 = function (a) {
        return BaseDOMEventProxy.cz(a);
    };
    BaseDOMEventProxy.cz = function (a) {
        var b;
        switch (a.which) {
            case 33:
                b = 10;
                break;
            case 34:
                b = 11;
                break;
            case 36:
                b = 13;
                break;
            case 37:
                b = 14;
                break;
            case 38:
                b = 15;
                break;
            case 39:
                b = 16;
                break;
            case 40:
                b = 17;
                break;
            case 9:
                b = 2;
                break;
            case 32:
                b = 9;
                break;
            case 13:
                b = 3;
                break;
            case 27:
                b = 8;
                break;
            case 16:
                b = 4;
                break;
            case 17:
                b = 5;
                break;
            case 18:
                b = 6;
                break;
            case 8:
                b = 1;
                break;
            case 35:
                b = 12;
                break;
            case 45:
                b = 18;
                break;
            case 46:
                b = 19;
                break;
            case 106:
                b = 78;
                break;
            case 107:
                b = 79;
                break;
            case 109:
                b = 80;
                break;
            case 110:
                b = 81;
                break;
            case 111:
                b = 82;
                break;
            case 220:
                b = 85;
                break;
            case 192:
                b = 86;
                break;
            case 191:
                b = 84;
                break;
            case 186:
                b = 83;
                break;
            case 189:
                b = 88;
                break;
            case 187:
                b = 87;
                break;
            default:
                if (112 <= a.which && a.which <= 123) {
                    b = (56 + a.which - 112);
                }
                else if (65 <= a.which && a.which <= 90) {
                    b = (30 + a.which - 65);
                }
                else if (48 <= a.which && a.which <= 57) {
                    b = (20 + a.which - 48);
                }
                else if (96 <= a.which && a.which <= 105) {
                    b = (68 + a.which - 96);
                }
                else {
                    b = 0;
                }
                break;
        }
        return b;
    };
    BaseDOMEventProxy.prototype.ce = function (a, b) {
        var c = this.c0(a);
        var d = c != 0;
        this.cv(a);
        if (d) {
            var e = false;
            if (b) {
                e = this.ag(c);
            }
            else {
                e = this.ah(c);
            }
            if (e) {
                this.ct(a);
            }
        }
    };
    BaseDOMEventProxy.prototype.cv = function (a) {
        this.ar = a;
        this.bh = 0;
        if (a.shiftKey) {
            this.bh = this.bh | 4;
        }
        if (a.altKey) {
            this.bh = this.bh | 1;
        }
        if (a.ctrlKey) {
            this.bh = this.bh | 2;
        }
        this.ak = a.button == 2;
    };
    BaseDOMEventProxy.prototype.bi = function () {
        var a = BaseDOMEventProxy.c3(this.b3);
        var b = a.left;
        var c = a.top;
        return { $type: Point_$type, x: b, y: c };
    };
    BaseDOMEventProxy.$t = markType(BaseDOMEventProxy, 'BaseDOMEventProxy', EventProxy.$);
    BaseDOMEventProxy.bs = false;
    BaseDOMEventProxy.bt = false;
    BaseDOMEventProxy.cb = 0;
    BaseDOMEventProxy.b8 = 0;
    return BaseDOMEventProxy;
}(EventProxy));
export { BaseDOMEventProxy };
/**
 * @hidden
 */
var DOMEventProxy = /** @class */ /*@__PURE__*/ (function (_super) {
    __extends(DOMEventProxy, _super);
    function DOMEventProxy(a, b, c) {
        var _this = _super.call(this) || this;
        _this.dd = 0;
        _this.df = "";
        _this.c5 = false;
        _this.de = null;
        _this.c7 = new Dictionary$2(String_$type, List$1.$.specialize(Delegate_$type), 0);
        _this.d2 = null;
        _this.db = -1;
        _this.d3 = null;
        _this.c9 = 0;
        _this.da = 0;
        _this.c8 = 5;
        _this.c4 = false;
        _this.d1 = null;
        _this.bw = c;
        _this.b2 = b;
        _this.ao = function (d) { return true; };
        _this.ab = false;
        DOMEventProxy.dc++;
        _this.dd = DOMEventProxy.dc;
        _this.df = ".DOMProxy" + _this.dd.toString();
        _this.bh = 0;
        _this.b3 = a;
        BaseDOMEventProxy.bs = false;
        try {
            BaseDOMEventProxy.bs = (window.navigator.msPointerEnabled && window.MSGesture !== undefined);
        }
        catch (d) {
        }
        BaseDOMEventProxy.bt = false;
        try {
            BaseDOMEventProxy.bt = (window.PointerEvent !== undefined);
        }
        catch (e) {
        }
        BaseDOMEventProxy.cb = _this.ca();
        BaseDOMEventProxy.b8 = _this.b9();
        _this.as(_this.b3, "");
        _this.an = function (f) { return true; };
        return _this;
    }
    DOMEventProxy.prototype.dg = function (a, b, c) {
    };
    DOMEventProxy.prototype.as = function (a, b) {
        var c = a;
        var d = this.df + b;
        if (!this.b2.supportsDOMEvents()) {
            return;
        }
        var e = new List$1(Delegate_$type, 0);
        this.c7.addItem(d, e);
        this.dg(a, b, e);
        if (!BaseDOMEventProxy.bx) {
            e.add(c.listen("mousemove", runOn(this, this.ci)));
            e.add(c.listen("mouseleave", runOn(this, this.ch)));
            e.add(c.listen("mousedown", runOn(this, this.cg)));
            e.add(c.listen("mouseup", runOn(this, this.ck)));
            e.add(this.b2.globalListen("window", "mouseup", runOn(this, this.cy)));
        }
        e.add(c.listen("keydown", runOn(this, this.cd)));
        e.add(c.listen("keyup", runOn(this, this.cf)));
        var source_ = this.b3.getNativeElement();
        if (!this.ae) {
            BaseDOMEventProxy.cs(source_);
        }
        if (BaseDOMEventProxy.bx) {
            var f = this.b3.getNativeElement();
            if ((window.MSGesture !== undefined)) {
                var gesture_ = new window.MSGesture();
                var container_ = f;
                gesture_.target = container_;
                this.de = gesture_;
                e.add(c.listen("MSGestureStart", runOn(this, this.dj)));
                e.add(c.listen("MSGestureChange", runOn(this, this.dh)));
                e.add(c.listen("MSGestureEnd", runOn(this, this.di)));
            }
            if (BaseDOMEventProxy.bt) {
                e.add(c.listen("pointerdown", runOn(this, this.dm)));
                e.add(c.listen("pointerup", runOn(this, this.dq)));
                e.add(c.listen("pointercancel", runOn(this, this.dl)));
                e.add(c.listen("pointermove", runOn(this, this.dn)));
                e.add(c.listen("pointerout", runOn(this, this.dp)));
                e.add(c.listen("lostpointercapture", runOn(this, this.dk)));
            }
            else {
                e.add(c.listen("MSPointerDown", runOn(this, this.dm)));
                e.add(c.listen("MSPointerUp", runOn(this, this.dq)));
                e.add(c.listen("MSPointerCancel", runOn(this, this.dl)));
                e.add(c.listen("MSPointerMove", runOn(this, this.dn)));
                e.add(c.listen("MSPointerOut", runOn(this, this.dp)));
                e.add(c.listen("MSLostPointerCapture", runOn(this, this.dk)));
            }
        }
        else {
            e.add(c.listen("gesturestart", runOn(this, this.dj)));
            e.add(c.listen("gesturechange", runOn(this, this.dh)));
            e.add(c.listen("gestureend", runOn(this, this.di)));
            e.add(c.listen("touchstart", runOn(this, this.dt)));
            e.add(c.listen("touchmove", runOn(this, this.ds)));
            e.add(c.listen("touchend", runOn(this, this.dr)));
        }
        if (this.bw) {
            e.add(c.listen("wheel", runOn(this, this.cl)));
        }
        else {
            e.add(c.listen("DOMMouseScroll", runOn(this, this.cj)));
            e.add(c.listen("mousewheel", runOn(this, this.cj)));
        }
    };
    DOMEventProxy.prototype.dq = function (e_) {
        var a = this.bq(e_);
        if (a) {
            this.b7 = this.b7 - 1;
            if (this.b7 < 0) {
                this.b7 = 0;
            }
        }
        if (this.b7 < 2 && this.c5 && a) {
            this.c5 = false;
            var b = (e_.originalEvent.scale);
            this.a3(this.c1, b);
        }
        else {
            if (a) {
                this.dr(e_);
            }
            else {
                this.ck(e_);
            }
        }
    };
    DOMEventProxy.prototype.dk = function (e_) {
        var a = this.bq(e_);
        if (a) {
            this.b7--;
            if (this.b7 < 0) {
                this.b7 = 0;
            }
        }
        if (this.b7 < 2 && this.c5 && a) {
            this.c5 = false;
            var b = (e_.originalEvent.scale);
            this.a3(this.c1, b);
        }
    };
    DOMEventProxy.prototype.dl = function (e_) {
        var a = this.bq(e_);
        if (a) {
            this.b7--;
            if (this.b7 < 0) {
                this.b7 = 0;
            }
        }
        if (this.b7 < 2 && this.c5 && a) {
            this.c5 = false;
            var b = (e_.originalEvent.scale);
            this.a3(this.c1, b);
        }
    };
    DOMEventProxy.prototype.dm = function (e_) {
        var a = this.bq(e_);
        if (this.de != null && a) {
            this.b7++;
            var mGesture_ = this.de;
            mGesture_.addPointer(e_.originalEvent.pointerId);
        }
        var eventSource_ = this.b3.getNativeElement();
        if (BaseDOMEventProxy.bt) {
            eventSource_.setPointerCapture(e_.originalEvent.pointerId);
        }
        else {
            eventSource_.msSetPointerCapture(e_.originalEvent.pointerId);
        }
        if (this.b7 > 1 && !this.c5 && a) {
            this.c5 = true;
            this.cx(e_);
            var b = (e_.originalEvent.scale);
            this.bc(this.c1, b);
        }
        else {
            if (a) {
                this.dt(e_);
            }
            else {
                this.cg(e_);
            }
        }
    };
    DOMEventProxy.prototype.dn = function (e_) {
        var a = this.bq(e_);
        if (this.c5) {
            return;
        }
        if (a) {
            this.ds(e_);
        }
        else {
            this.ci(e_);
        }
    };
    DOMEventProxy.prototype.dp = function (e_) {
        var a = this.bq(e_);
        if (this.c5) {
            return;
        }
        if (a) {
        }
        else {
            this.ch(e_);
        }
    };
    DOMEventProxy.prototype.dj = function (e_) {
        this.br = true;
        this.cv(e_);
        this.cx(e_);
        this.dv();
        if (this.ad(this.c2, true, false)) {
            this.ct(e_);
            if (BaseDOMEventProxy.bx && this.b7 < 2) {
                return;
            }
            var a = (e_.originalEvent.scale);
            this.bc(this.c1, a);
        }
    };
    DOMEventProxy.prototype.dh = function (e_) {
        this.br = true;
        this.cv(e_);
        this.cx(e_);
        if (this.ad(this.c2, true, false)) {
            this.ct(e_);
            if (BaseDOMEventProxy.bx && this.b7 < 2) {
                return;
            }
            var a = (e_.originalEvent.scale);
            this.bb(this.c1, a);
        }
    };
    DOMEventProxy.prototype.di = function (e_) {
        this.ct(e_);
        var a = (e_.originalEvent.scale);
        this.br = false;
        this.cv(e_);
        this.cx(e_);
        if (!BaseDOMEventProxy.bx || this.c5) {
            this.a3(this.c1, a);
        }
    };
    DOMEventProxy.prototype.dt = function (e_) {
        this.br = true;
        this.cv(e_);
        this.cx(e_);
        this.d2 = this.c1;
        if (this.ad(this.c2, true, false)) {
            if (!this.ab) {
                this.ct(e_);
            }
            else {
                this.bv = true;
            }
            this.a9(this.c2, false, true);
            this.a6(this.c2);
            this.ay(this.c1, true);
            this.dy();
        }
    };
    DOMEventProxy.prototype.dy = function () {
        if (this.db == -1) {
            this.c9 = this.c2.x;
            this.da = this.c2.y;
            this.db = this.b2.setTimeout(runOn(this, this.dw), 1500);
        }
    };
    DOMEventProxy.prototype.dv = function () {
        if (Math.abs(this.c9 - this.c2.x) > this.c8 || Math.abs(this.da - this.c2.y) > this.c8) {
            this.dz();
        }
    };
    DOMEventProxy.prototype.dz = function () {
        if (this.db != -1) {
            window.clearTimeout(this.db);
            this.db = -1;
        }
    };
    DOMEventProxy.prototype.dw = function () {
        this.db = -1;
        if (this.bv) {
            this.bv = false;
            this.cc();
        }
        this.a4(this.c1);
    };
    DOMEventProxy.prototype.ds = function (a) {
        this.br = true;
        this.cv(a);
        this.cx(a);
        if (this.bv) {
            if (this.ad(this.c2, true, false) && this.c6()) {
                this.bv = false;
                this.cc();
            }
        }
        this.dv();
        this.d0();
        if (this.ad(this.c2, true, false) && this.b7 == 1 && !this.bv) {
            this.ct(a);
            if (!this.c4) {
                this.c4 = true;
                this.d1 = this.c1;
                this.a2(this.d1);
            }
            else {
                this.a9(this.c2, true, true);
                this.ax(this.c1, true);
                this.a1(this.c1);
            }
        }
    };
    DOMEventProxy.prototype.c6 = function () {
        var a = { $type: Point_$type, x: this.d2.x - this.c1.x, y: this.d2.y - this.c1.y };
        if (Math.abs(a.x) < 2 && Math.abs(a.y) < 2) {
            return false;
        }
        if (Math.abs(a.x) > Math.abs(a.y)) {
            a.y = 0;
        }
        if (Math.abs(a.y) > Math.abs(a.x)) {
            a.x = 0;
        }
        return this.ao(a);
    };
    DOMEventProxy.prototype.dr = function (a) {
        this.br = false;
        this.cv(a);
        this.cx(a);
        this.dz();
        if (this.bv) {
            this.bv = false;
            this.cc();
        }
        this.ct(a);
        this.a9(this.c2, false, true);
        this.ba(this.c2);
        if (this.b7 == 0) {
            this.dx(this.c2);
            this.cq();
        }
        if (this.c4 && this.b7 == 0) {
            this.c4 = false;
            this.d1 = null;
            this.a0(this.c1);
            this.cq();
        }
        this.aw(this.c1, true, this.b7 > 0);
    };
    DOMEventProxy.prototype.dx = function (a) {
        if (Rect.l_op_Equality(this.d3, null)) {
            this.d3 = new Rect(0, a.x - 50, a.y - 50, 100, 100);
            this.b2.setTimeout(runOn(this, this.d0), 500);
        }
        else {
            if (a.x >= this.d3.x && a.x <= this.d3.right && a.y >= this.d3.y && a.y <= this.d3.bottom) {
                this.d0();
                this.az(a);
            }
        }
    };
    DOMEventProxy.prototype.d0 = function () {
        this.d3 = null;
    };
    DOMEventProxy.prototype.du = function (a) {
        if (this.c7.containsKey(a)) {
            var b = this.c7.item(a);
            this.c7.removeItem(a);
            for (var c = 0; c < b.count; c++) {
                b._inner[c]();
            }
            b.clear();
        }
    };
    DOMEventProxy.prototype.bg = function (a, b) {
        var c = a;
        var d = this.df + b;
        this.du(d);
    };
    DOMEventProxy.prototype.au = function () {
        if (this.b3 == null) {
            return;
        }
        this.du(this.df);
        this.b3 = null;
    };
    DOMEventProxy.$t = markType(DOMEventProxy, 'DOMEventProxy', BaseDOMEventProxy.$);
    DOMEventProxy.dc = 0;
    return DOMEventProxy;
}(BaseDOMEventProxy));
export { DOMEventProxy };
